10 REM  1997/7
20 REM        DRAW ELEMENT, DEFORMATION AND NODAL FORCE 
30 REM           ------- F3DR1.BAS FOR WINDOWS95 -------
40 REM                    BY TAKAYUKI HIRAI
50 DEFSTR Z
60 DIM MV(20,2000),B(3,8000),D(3,8000,3),DU(3,8000),FP(3,8000),Q(3,3)
65 DIM X(24000),C(3,8000),E(3,8000),F(3,8000),G(3,8000,3)
66 DIM EE(3,8000),FF(3,8000),GG(3,8000,3)
67 DIM L(24000),M(24000),N(24000,3),JJ(12,3),MOU(8000,2)
70 OPEN "R1" FOR INPUT AS #1
72 JJ(1,1)=1:JJ(1,2)=9:JJ(1,3)=2
74 JJ(2,1)=2:JJ(2,2)=10:JJ(2,3)=3
76 JJ(3,1)=3:JJ(3,2)=11:JJ(3,3)=4
78 JJ(4,1)=4:JJ(4,2)=12:JJ(4,3)=1
80 JJ(5,1)=5:JJ(5,2)=17:JJ(5,3)=6
82 JJ(6,1)=6:JJ(6,2)=18:JJ(6,3)=7
84 JJ(7,1)=7:JJ(7,2)=19:JJ(7,3)=8
86 JJ(8,1)=8:JJ(8,2)=20:JJ(8,3)=5
88 JJ(9,1)=1:JJ(9,2)=13:JJ(9,3)=5
90 JJ(10,1)=2:JJ(10,2)=14:JJ(10,3)=6
92 JJ(11,1)=3:JJ(11,2)=15:JJ(11,3)=7
94 JJ(12,1)=4:JJ(12,2)=16:JJ(12,3)=8
96 PRINT " "
98 PRINT "      PRE- & POST-DEFORMED ELEMENT FIGURE,  FIGU = 0"
100 PRINT "      PRE-DEFORMED ELEMENT FIGURE        ,  FIGU = 1"
102 PRINT "      POST-DEFORMED ELEMENT FIGURE       ,  FIGU = 2"
104 PRINT "      NODAL FORCE                        ,  FIGU = 3"
106 PRINT " "
108 INPUT "                    FIGU = ";FIGU
110 IF FIGU<>3 THEN GOTO 126
112 PRINT " "
114 PRINT "      ALL NODAL FORCE        ,  FXYZ = 0"
116 PRINT "      X-DIRECTION NODAL FORCE,  FXYZ = 1"
118 PRINT "      Y-DIRECTION NODAL FORCE,  FXYZ = 2"
120 PRINT "      Z-DIRECTION NODAL FORCE,  FXYZ = 3"
122 PRINT " "
124 INPUT "                   FXYZ = ";FXYZ
126 PRINT " "
128 input "            SCALE OF DISPLACEMENT =";SCD
130 INPUT "            SCALE OF NODAL FORCE  =";SCF
132 IF ABS(SCD)<0.000001 THEN SCD=0.000001
134 IF ABS(SCF)<0.000001 THEN SCF=0.000001
136 PRINT " "
163 PRINT "   INPUT VIEW DIRECTION":
164 PRINT "      Q1 = ANGLE(DEGREE) FROM X-AXIS TOWARD Y-AXIS" 
165 PRINT "      Q2 = ANGLE(DEGREE) FROM XY-PLANE" 
166 PRINT " ":INPUT "       Q1 =";Q1
167 PRINT " ":INPUT "       Q2 =";Q2:PRINT " "
168 PRINT "   INPUT ROTATION OF VIEW DIRECTION"
169 PRINT "      Q3 = ANGLE(DEGREE) OF LEFT-HANDED ROTATION"
170 PRINT " ":INPUT "       Q3 =";Q3
171 P1=Q1*0.017453:P2=Q2*0.017453:P9=COS(P2)
172 V1=COS(P1)*P9:V2=SIN(P1)*P9:V3=SIN(P2)
175 VV=SQR(V1*V1+V2*V2+V3*V3)
176 IF VV>0.0001 THEN GOTO 179
177 PRINT " ":PRINT " BAD Q1,Q2     INPUT AGAIN"
178 GOTO 136
179 V1=V1/VV:V2=V2/VV:V3=V3/VV
180 H1=SIN(P1):H2=-COS(P1):H3=0
186 VV=SQR(H1*H1+H2*H2+H3*H3)
188 IF VV>0.0001 THEN GOTO 194
190 PRINT " ":PRINT " BAD Q1,Q2     INPUT AGAIN"
192 GOTO 136
194 H1=H1/VV:H2=H2/VV:H3=H3/VV
196 T1=V2*H3-V3*H2:T2=-V1*H3+V3*H1:T3=V1*H2-V2*H1
198 VV=H1*V2*T3+H2*V3*T1+H3*V1*T2-H1*V3*T2-H2*V1*T3-H3*V2*T1
200 IF ABS(VV)>0.001 THEN GOTO 204
201 PRINT " ":PRINT " BAD VIEW DIRECTION     INPUT AGAIN"
202 GOTO 136
204 HH=H1*V1+H2*V2+H3*V3:HHH=HH*HH
206 IF HHH<0.0001 THEN GOTO 209
207 PRINT " ":PRINT " BAD VIEW DIRECTION     INPUT AGAIN"
208 GOTO 136
209 Q(1,1)=(V2*T3-V3*T2)/VV:Q(1,2)=-(H2*T3-H3*T2)/VV:Q(1,3)=(H2*V3-H3*V2)/VV
210 Q(2,1)=-(V1*T3-V3*T1)/VV:Q(2,2)=(H1*T3-H3*T1)/VV:Q(2,3)=-(H1*V3-H3*V1)/VV
211 Q(3,1)=(V1*T2-V2*T1)/VV:Q(3,2)=-(H1*T2-H2*T1)/VV:Q(3,3)=(H1*V2-H2*V1)/VV
212 P3=Q3*0.017453:P4=SIN(P3):P5=COS(P3)
213 QQ(1,1)=P5:QQ(1,2)=P4:QQ(2,1)=-P4:QQ(2,2)=P5
216 REM  
217 FOR I=1 TO 6:INPUT #1,ZZ:NEXT I
218 Z1=LEFT$(ZZ,22):ZM=RIGHT$(ZZ,5)
220 INPUT #1,ZZ:INPUT #1,ZZ:INPUT #1,ZZ
221 Z1=LEFT$(ZZ,15):NELE=VAL(RIGHT$(Z1,5))
222 Z2=LEFT$(ZZ,38):NODT=VAL(RIGHT$(Z2,5))
223 Z3=LEFT$(ZZ,57):NMAT=VAL(RIGHT$(Z3,3))
224 REM
225 REM    ------ INPUT ELEMENT NUMBERS -------
226 PRINT " "
227 PRINT "  INPUT THE ELEMENTS NUMBER TO DRAW"
230 PRINT "       ALL ELEMENTS                WAY = 0"
231 PRINT "       INPUT FROM FILE D2          WAY = 1"
232 PRINT "       INPUT FROM KEY-BOARD        WAY = 2"
233 PRINT " ":INPUT "             WAY =";WAY
234 PRINT " "
240 IF WAY=0 THEN GOTO 308
242 IF WAY=2 THEN GOTO 259
244 OPEN "D2" FOR INPUT AS #2
245 FOR I9=1 TO 2000
246 IF EOF(2)=-1 THEN GOTO 258
248 INPUT #2,MOU(I9,1)
249 IF MOU(I9,1)>89999! THEN GOTO 258
250 IF MOU(I9,1)<1 THEN GOTO 253
251 IF MOU(I9,1)>NELE THEN GOTO 253
252 NEXT I9
253 PRINT " ":PRINT "  BAD : WRONG ELEMENT NUMBER TO DRAW = ";MOU(I9,1)
254 PRINT " ":PRINT " CORRECT DATA IN FILE D2"
255 PRINT " ":INPUT " PUSH ENTER KEY ";Z3
256 GOTO 1900
258 CLOSE #2:GOTO 277
259 PRINT "         INPUT ELEMENT NUMBER,   END DATA = 99999 "
260 FOR I9=1 TO 2000
262 PRINT " ":INPUT "        ELEMENT NUMBER =";MOU(I9,1)
264 IF MOU(I9,1)>89999! THEN GOTO 277
266 IF MOU(I9,1)<1 THEN GOTO 271
268 IF MOU(I9,1)>NELE THEN GOTO 271
270 GOTO 275
271 PRINT " ":PRINT "  BAD : WRONG ELEMENT NUMBER TO DRAW = ";MOU(I9,1)
272 PRINT " ":PRINT "           INPUT AGAIN"
273 PRINT " ":GOTO 262
275 NEXT I9
277 DRE=I9-1
308 REM
340 REM ------- READING MODEL DATA --------
350 PRINT " ":PRINT "   MODEL = ";ZM
365 PRINT " "
367 PRINT "  ELEMENTS, TOTAL NODES, MATERIALS = ";NELE,NODT,NMAT
370 INPUT #1,ZZ:INPUT #1,ZZ
372 FOR I=1 TO NODT
374 INPUT #1,ZZ
376 B(3,I)=VAL(RIGHT$(ZZ,15)):Z1=RIGHT$(ZZ,30):B(2,I)=VAL(LEFT$(Z1,15))
378 Z1=RIGHT$(ZZ,45):B(1,I)=VAL(LEFT$(Z1,15))
380 NEXT I
390 INPUT #1,ZZ:INPUT #1,ZZ
400 FOR I=1 TO NMAT:INPUT #1,ZZ:NEXT I
410 FOR I=1 TO 3:INPUT #1,ZZ:NEXT I
420 FOR I=1 TO NELE
422 INPUT #1,ZZ
424 Z1=RIGHT$(ZZ,109):A1=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,105):A2=VAL(LEFT$(Z1,4))
426 Z1=RIGHT$(ZZ,101):A3=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,97):A4=VAL(LEFT$(Z1,4))
428 Z1=RIGHT$(ZZ,93):A5=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,89):A6=VAL(LEFT$(Z1,4))
430 Z1=RIGHT$(ZZ,85):A7=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,81):A8=VAL(LEFT$(Z1,4))
432 Z1=RIGHT$(ZZ,77):A9=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,73):A0=VAL(LEFT$(Z1,4))
434 Z1=RIGHT$(ZZ,69):B1=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,65):B2=VAL(LEFT$(Z1,4))
436 Z1=RIGHT$(ZZ,61):B3=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,57):B4=VAL(LEFT$(Z1,4))
438 Z1=RIGHT$(ZZ,53):B5=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,49):B6=VAL(LEFT$(Z1,4))
440 Z1=RIGHT$(ZZ,45):B7=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,41):B8=VAL(LEFT$(Z1,4))
442 Z1=RIGHT$(ZZ,37):B9=VAL(LEFT$(Z1,4)):Z1=RIGHT$(ZZ,33):B0=VAL(LEFT$(Z1,4))
444 MV(1,I)=A1:MV(2,I)=A2:MV(3,I)=A3:MV(4,I)=A4:MV(5,I)=A5
446 MV(6,I)=A6:MV(7,I)=A7:MV(8,I)=A8:MV(9,I)=A9:MV(10,I)=A0
448 MV(11,I)=B1:MV(12,I)=B2:MV(13,I)=B3:MV(14,I)=B4:MV(15,I)=B5
450 MV(16,I)=B6:MV(17,I)=B7:MV(18,I)=B8:MV(19,I)=B9:MV(20,I)=B0
452 NEXT I
460 FOR I=1 TO NODT
461 PRINT I,B(1,I),B(2,I),B(3,I):NEXT I
462 FOR I=1 TO NELE
463 A1=MV(1,I):A2=MV(2,I):A3=MV(3,I):A4=MV(4,I):A5=MV(5,I)   
464 A6=MV(6,I):A7=MV(7,I):A8=MV(8,I):A9=MV(9,I):A0=MV(10,I)   
465 B1=MV(11,I):B2=MV(12,I):B3=MV(13,I):B4=MV(14,I):B5=MV(15,I)   
466 B6=MV(16,I):B7=MV(17,I):B8=MV(18,I):B9=MV(19,I):B0=MV(20,I)   
467 PRINT I,A1,A2,A3,A4,A5,A6,A7,A8,A9,A0,B1,B2,B3,B4,B5,B6,B7,B8,B9,B0
468 NEXT I
469 INPUT #1,ZZ:INPUT #1,ZZ:INPUT #1,ZZ
470 FOR I=1 TO NODT
472 INPUT #1,A1,A2,A3,A4,A5,A6,A7,A8,A9,A0
474 PRINT A1,A2,A3,A4,A5,A6,A7,A8,A9,A0
476 FP(1,I)=A5:FP(2,I)=A6:FP(3,I)=A7
478 DU(1,I)=A8:DU(2,I)=A9:DU(3,I)=A0
480 next I
482 IF WAY=0 THEN GOTO 518
490 DRN=20
492 FOR I=1 TO 20
494 MOU(I,2)=MV(I,MOU(1,1))
496 NEXT I
498 IF DRE=1 THEN GOTO 562
500 FOR I=2 TO DRE
502 FOR J=1 TO 20
504 FOR K=1 TO DRN
506 IF MV(J,MOU(I,1))=MOU(K,2) THEN GOTO 512
508 NEXT K
510 DRN=DRN+1:MOU(DRN,2)=MV(J,MOU(I,1))
512 NEXT J
514 NEXT I
516 GOTO 562
518 DRE=NELE:DRN=NODT
520 FOR I=1 TO NELE
522 MOU(I,1)=I:NEXT I
524 FOR I=1 TO NODT
526 MOU(I,2)=I:NEXT I
562 REM
564 REM  ----------- SCALING ----------
566 FOR I=1 TO NODT
568 FOR J=1 TO 3
570 C(J,I)=B(J,I)+DU(J,I)*SCD
572 FOR K=1 TO 3
580 D(J,I,K)=B(J,I):NEXT K
586 D(J,I,J)=D(J,I,J)+FP(J,I)*SCF
588 NEXT J:NEXT I
590 FOR I=1 TO NODT
592 FOR J=1 TO 3
594 EE(J,I)=0.0:FF(J,I)=0.0
595 GG(J,I,1)=0.0:GG(J,I,2)=0.0:GG(J,I,3)=0.0
596 FOR K=1 TO 3
598 EE(J,I)=EE(J,I)+B(K,I)*Q(K,J)
600 FF(J,I)=FF(J,I)+C(K,I)*Q(K,J)
602 FOR KK=1 TO 3
604 GG(J,I,KK)=GG(J,I,KK)+D(K,I,KK)*Q(K,J)
606 NEXT KK
608 NEXT K:NEXT J:NEXT I
620 FOR I=1 TO NODT
622 E(2,I)=EE(2,I)
623 F(2,I)=FF(2,I)
624 G(2,I,1)=GG(2,I,1):G(2,I,2)=GG(2,I,2):G(2,I,3)=GG(2,I,3)
625 E(1,I)=QQ(1,1)*EE(1,I)+QQ(1,2)*EE(3,I)
626 E(3,I)=QQ(2,1)*EE(1,I)+QQ(2,2)*EE(3,I)
627 F(1,I)=QQ(1,1)*FF(1,I)+QQ(1,2)*FF(3,I)
628 F(3,I)=QQ(2,1)*FF(1,I)+QQ(2,2)*FF(3,I)
630 FOR KK=1 TO 3
634 G(1,I,KK)=QQ(1,1)*GG(1,I,KK)+QQ(1,2)*GG(3,I,KK)
635 G(3,I,KK)=QQ(2,1)*GG(1,I,KK)+QQ(2,2)*GG(3,I,KK)
636 NEXT KK
638 NEXT I
654 FOR I=1 TO NODT
655 E(3,I)=-E(3,I)
656 F(3,I)=-F(3,I)
657 FOR KK=1 TO 3
658 G(3,I,KK)=-G(3,I,KK)
660 NEXT KK:NEXT I
670 XA=999999!:XB=-999999!:YA=999999!:YB=-999999!
672 FOR I9=1 TO DRN
673 I=MOU(I9,2)
674 IF XA>E(1,I) THEN XA=E(1,I)
676 IF XB<E(1,I) THEN XB=E(1,I)
678 IF YA>E(3,I) THEN YA=E(3,I)
680 IF YB<E(3,I) THEN YB=E(3,I)
682 IF XA>F(1,I) THEN XA=F(1,I)
684 IF XB<F(1,I) THEN XB=F(1,I)
700 IF YA>F(3,I) THEN YA=F(3,I)
710 IF YB<F(3,I) THEN YB=F(3,I)
720 FOR KK=1 TO 3
730 IF XA>G(1,I,KK) THEN XA=G(1,I,KK)
740 IF XB<G(1,I,KK) THEN XB=G(1,I,KK)
750 IF YA>G(3,I,KK) THEN YA=G(3,I,KK)
760 IF YB<G(3,I,KK) THEN YB=G(3,I,KK)
770 NEXT KK
780 NEXT I9
790 XM=XB-XA:YM=YB-YA
800 SS=180/YM
810 IF XM*4>YM*6 THEN SS=290/XM
820 FOR I=1 TO NODT
830 L(2*I-1)=(E(1,I)-XA)*SS*2+10
840 L(2*I)=195-(E(3,I)-YA)*SS
850 M(2*I-1)=(F(1,I)-XA)*SS*2+10
860 M(2*I)=195-(F(3,I)-YA)*SS
865 FOR KK=1 TO 3
870 N(2*I-1,KK)=(G(1,I,KK)-XA)*SS*2+10
880 N(2*I,KK)=195-(G(3,I,KK)-YA)*SS
885 NEXT KK
890 NEXT I
900 REM
910 REM ----- DRAW PRE DEFORMED FIGURE -----
920 #include"WINDOWS.BI"
930 var FORM as object
940 var BITMAP1 as object
950 SETMAPMODE 1
955 SETREDRAWMODE 1
960 FORM.ATTACH GETHWND
962 BITMAPOBJECT BITMAP1
964 view (0,0)-(636,433)
966 window (0,-3)-(620,210)
968 color 0,15
970 CLS
973 if FIGU><1 then goto 976
974 print"    MODEL=";ZM:GOTO 990
976 IF FIGU=3 THEN GOTO  986
978 SSSS=8/SS/SCD
982 PRINT"    DISPLACEMENT SCALE=";SSSS;"  MODEL=";ZM
984 GOTO 990
986 SSSS=8/SS/SCF
988 print"    NODAL FORCE SCALE=";SSSS;"  MODEL=";ZM
990 IF FIGU=2 THEN GOTO 1040
995 FOR I6=1 TO DRE
996 I=MOU(I6,1)
998 FOR J=1 TO 12
1000 X1=L(2*MV(JJ(J,1),I)-1):X2=L(2*MV(JJ(J,2),I)-1):X3=L(2*MV(JJ(J,3),I)-1)
1002 Y1=L(2*MV(JJ(J,1),I)):Y2=L(2*MV(JJ(J,2),I)):Y3=L(2*MV(JJ(J,3),I))
1004 FOR K=1 TO 8:K1=-1+(K-1)/4:K2=-1+K/4
1006 XX1=CINT(K1*(K1-1)*X1/2+(1-K1)*(K1+1)*X2+K1*(K1+1)*X3/2)
1008 YY1=CINT(K1*(K1-1)*Y1/2+(1-K1)*(K1+1)*Y2+K1*(K1+1)*Y3/2)
1010 XX2=CINT(K2*(K2-1)*X1/2+(1-K2)*(K2+1)*X2+K2*(K2+1)*X3/2)
1012 YY2=CINT(K2*(K2-1)*Y1/2+(1-K2)*(K2+1)*Y2+K2*(K2+1)*Y3/2)
1014 line(XX1,YY1)-(XX2,YY2),pset,0:NEXT K
1015 NEXT J:NEXT I6
1020 REM
1030 REM ----- DRAW DEFORMED FIGURE -----
1040 if FIGU=1 then goto 1850
1042 IF FIGU=3 THEN GOTO 1100
1044 FOR I6=1 TO DRE
1045 I=MOU(I6,1)
1046 FOR J=1 TO 12
1048 X1=M(2*MV(JJ(J,1),I)-1):X2=M(2*MV(JJ(J,2),I)-1):X3=M(2*MV(JJ(J,3),I)-1)
1050 Y1=M(2*MV(JJ(J,1),I)):Y2=M(2*MV(JJ(J,2),I)):Y3=M(2*MV(JJ(J,3),I))
1054 FOR K=1 TO 8:K1=-1+(K-1)/4:K2=-1+K/4
1056 XX1=CINT(K1*(K1-1)*X1/2+(1-K1)*(K1+1)*X2+K1*(K1+1)*X3/2)
1058 YY1=CINT(K1*(K1-1)*Y1/2+(1-K1)*(K1+1)*Y2+K1*(K1+1)*Y3/2)
1060 XX2=CINT(K2*(K2-1)*X1/2+(1-K2)*(K2+1)*X2+K2*(K2+1)*X3/2)
1062 YY2=CINT(K2*(K2-1)*Y1/2+(1-K2)*(K2+1)*Y2+K2*(K2+1)*Y3/2)
1064 line(XX1,YY1)-(XX2,YY2),pset,8:NEXT K
1065 NEXT J:NEXT I6
1070 line(5,6)-(21,6),pset,8:line(5,6)-(5,-2),pset,8
1080 IF FIGU<>3 THEN GOTO 1850
1100 REM
1110 REM ----- DRAW NODAL FORCE -----
1120 IF FXYZ=0 THEN GOTO 1330
1130 FOR I6=1 TO DRN
1135 I=MOU(I6,2)
1140 X1=CINT(L(2*I-1)):Y1=CINT(L(2*I))
1150 X2=CINT(N(2*I-1,FXYZ)):Y2=CINT(N(2*I,FXYZ))
1160 line(X1,Y1)-(X2,Y2),pset,5
1170 IF ABS(FP(FXYZ,I)*SCF*SS*2)<2 THEN GOTO 1310
1180 UU=(N(2*I-1,FXYZ)-L(2*I-1))*2:VV=N(2*I,FXYZ)-L(2*I)
1190 IF ABS(UU)<0.00001 GOTO 1250
1200 FUV=ATN(VV/UU)
1210 IF UU>0.0 THEN GOTO 1270      
1220 FUV=FUV+3.1416
1230 IF VV<0.0 THEN FUV=FUV-6.2832
1240 GOTO 1270       
1250 FUV=1.5708
1260 IF VV<0.0 THEN FUV=FUV-3.1416
1270 F1=CINT(COS(FUV+2.3562)*4):F2=CINT(SIN(FUV+2.3562)*2)
1280 F3=CINT(COS(FUV-2.3562)*4):F4=CINT(SIN(FUV-2.3562)*2)
1290 line(X2,Y2)-(X2+F1,Y2+F2),pset,3
1300 line(X2,Y2)-(X2+F3,Y2+F4),pset,3
1310 NEXT I6
1320 GOTO 1850
1330 REM
1332 FOR I6=1 TO DRN
1335 I=MOU(I6,2)
1340 FOR KK=1 TO 3
1360 X1=CINT(L(2*I-1)):Y1=CINT(L(2*I))
1370 X2=CINT(N(2*I-1,KK)):Y2=CINT(N(2*I,KK))
1380 line(X1,Y1)-(X2,Y2),pset,5
1390 IF ABS(FP(KK,I)*SCF*SS*2)<2 THEN GOTO 1530
1400 UU=(N(2*I-1,KK)-L(2*I-1))*2:VV=N(2*I,KK)-L(2*I)
1410 IF ABS(UU)<0.00001 GOTO 1470
1420 FUV=ATN(VV/UU)
1430 IF UU>0.0 THEN GOTO 1490      
1440 FUV=FUV+3.1416
1450 IF VV<0.0 THEN FUV=FUV-6.2832
1460 GOTO 1490       
1470 FUV=1.5708
1480 IF VV<0.0 THEN FUV=FUV-3.1416
1490 F1=CINT(COS(FUV+2.3562)*4):F2=CINT(SIN(FUV+2.3562)*2)
1500 F3=CINT(COS(FUV-2.3562)*4):F4=CINT(SIN(FUV-2.3562)*2)
1510 line(X2,Y2)-(X2+F1,Y2+F2),pset,3
1520 line(X2,Y2)-(X2+F3,Y2+F4),pset,3
1530 NEXT KK       
1540 NEXT I6
1550 line(5,6)-(21,6),pset,5:line(5,6)-(5,-2),pset,5
1840 REM
1850 BITMAP1.CREATEBITMAP 636,433
1852 BITMAP1.BITBLT 0,0,636,433,FORM,0,-3
1854 BITMAP1.SAVEFILE"AAA.BMP"
1856 BITMAP1.DELETEOBJECT
1858 cls
1860 BITMAP1.LOADFILE"AAA.BMP"
1862 FORM.BITBLT 0,-3,636,433,BITMAP1,0,0
1863 for I8=1 to 9000
1866 wait 10
1870 Z4=inkey$
1880 if Z4="Q" then goto 1900
1882 if Z4="q" then goto 1900
1884 if Z4="S" then goto 1900
1886 if Z4="s" then goto 1900
1888 next I8
1900 END
